(ns com.aurellem.gb.rival-name
  (:use (com.aurellem.gb gb-driver util characters))
  (:import [com.aurellem.gb.gb_driver SaveState]))


(def rival-name-start-address 0xD349)

(def rival-name-width 12)

(defn read-rival-name
  ([^SaveState state]
     (read-name (subvec (vec (memory state))
                        rival-name-start-address
                        (+ rival-name-start-address
                           rival-name-width))))
  ([] (read-rival-name @current-state)))

(defn set-rival-name
  ([^SaveState state new-name]
     (assert (<= (count new-name) 10))
     (let [codes (str->character-codes new-name)]
       (set-memory-range state
                         rival-name-start-address
                         (concat codes [end-of-name-sentinel]))))
  ([new-name] (set-rival-name @current-state new-name)))
     

